/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.celestial.findhighestnumber;

import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.Rule;
import org.junit.rules.ExpectedException;

/**
 *
 * @author Admin
 */
public class ManageArraysTest 
{
    @Rule
    public  final   ExpectedException exception = ExpectedException.none();
    
    @Test
    public  void    find_highest_in_array_of_one() throws EmptyArrayException
    {
        // arrange
        int array[] = {3};
        ManageArrays cut = new ManageArrays();
        int expResult = 3;
        int result;
        
        // act
        result = cut.findHighest( array );
        
       // assert
        assertEquals(expResult, result);
    }
    
    @Test
    public  void    find_highest_in_array_of_two_highest_in_front() throws EmptyArrayException
    {
        // arrange
        int array[] = {4, 3};
        ManageArrays cut = new ManageArrays();
        int expResult = 4;
        int result;
        
        // act
        result = cut.findHighest( array );
        
       // assert
        assertEquals(expResult, result);
    }

    @Test
    public  void    find_highest_in_array_of_two_highest_last() throws EmptyArrayException
    {
        // arrange
        int array[] = {3, 4};
        ManageArrays cut = new ManageArrays();
        int expResult = 4;
        int result;
        
        // act
        result = cut.findHighest( array );
        
       // assert
        assertEquals(expResult, result);
    }

    @Test
    public  void    find_highest_in_array_of_any_number() throws EmptyArrayException
    {
        // arrange
        int array[] = {3, 4, 7, 2};
        ManageArrays cut = new ManageArrays();
        int expResult = 7;
        int result;
        
        // act
        result = cut.findHighest( array );
        
       // assert
        assertEquals(expResult, result);
    }

    @Test( expected = EmptyArrayException.class )
    public  void    find_highest_in_empty_array() throws EmptyArrayException
    {
        // arrange
        int array[] = {};
        ManageArrays cut = new ManageArrays();
        
        // act
        cut.findHighest( array );
    }
}
